function BarProfilerSaveBars(Location, ProfileName, Silent)
	local SlotLoop
	for SlotLoop = 1, 120 do 
		me = BarProfilerDb.Realms[BarProfilerDb.CurrentRealm].Characters[BarProfilerDb.CurrentCharacter][Location][ProfileName][SlotLoop]
		me.Type, me.GlobalID, me.SubType, me.Texture, me.Name, me.Body = BarProfilerGetAction(SlotLoop)
	end
	BarProfilerDb.Realms[BarProfilerDb.CurrentRealm].Characters[BarProfilerDb.CurrentCharacter][Location][ProfileName].DataCheck = 1
	if Silent == false then
		BarProfiler:Print ("Current action bars saved to profile", ProfileName)
	end
end
function BarProfilerLoadBars(Location, ProfileName, Silent)
	local SlotLoop
	for SlotLoop = 1, 120 do
		me = BarProfilerDb.Realms[BarProfilerDb.CurrentRealm].Characters[BarProfilerDb.CurrentCharacter][Location][ProfileName][SlotLoop]
		if me.Ignore == nil then
			BarProfilerPickUpAction(SlotLoop, me.Type, me.GlobalID, me.SubType, me.Name, me.Body)
			BarProfilerPlaceAction(SlotLoop)
		end
	end
	if Silent == false then
		BarProfiler:Print("Loaded action bars from profile", ProfileName)
	end
	BarProfilerDb.Realms[BarProfilerDb.CurrentRealm].Characters[BarProfilerDb.CurrentCharacter].LoadedProfile = ProfileName
end
function BarProfilerGetAction(SlotLoop)
	local Type, GlobalID, SubType, Texture, Name, Body
	Type, GlobalID, SubType = GetActionInfo(SlotLoop)
	Texture = GetActionTexture(SlotLoop)
	if Type == 'macro' then
		Name = GetMacroInfo(GlobalID) --macroslot
		Body = GetMacroBody(GlobalID)
	elseif Type == 'companion' then
		for CompanionLoop = 1, GetNumCompanions(SubType) do  
			local creatureID, creatureName, creatureSpellID = GetCompanionInfo(SubType, CompanionLoop)	--unnescarscary variables here
			if creatureSpellID == GlobalID then
				Name = creatureName
			end
		end
	end
	if Texture == nil then
		Texture = "Interface\\BUTTONS\\UI-EmptySlot-Disabled"
	end
	return Type, GlobalID, SubType, Texture, Name, Body
end
function BarProfilerPickUpAction(SlotLoop, Type, GlobalID, SubType, Name, Body)	--try and rewrite this to have a pickup then place function
	if Type == 'spell' then
		PickupSpell(GlobalID)
	elseif Type == 'item' then
		PickupItem(GlobalID)
	elseif Type == 'macro' then	
		if Body == nil then
			PickupMacro(Name)
		else
			for MacroLoop = 1, 54 do
				local Body2 = GetMacroBody(MacroLoop)
				local Name2 = GetMacroInfo(MacroLoop)
				if Body == Body2 and Name2 == Name then
					PickupMacro(MacroLoop)
				end
			end
		end
	elseif Type == 'equipmentset' then
		PickupEquipmentSetByName (GlobalID)
	elseif Type == 'companion' then
		if SubType == 'MOUNT' then	--Need to save the mount ID found in mountloop
			for MountLoop = 1, GetNumCompanions("MOUNT") do  
				local creatureID, creatureName, creatureSpellID, icon, issummoned, mountType = GetCompanionInfo("MOUNT", MountLoop)	--unnescarscary variables here
				if creatureSpellID == GlobalID then
					PickupCompanion("MOUNT", MountLoop)
				end
			end
		elseif SubType == 'CRITTER' then	--Need to save the Critter ID found in mountloop
			for CritterLoop = 1, GetNumCompanions("CRITTER") do
				local creatureID, creatureName, creatureSpellID, icon, issummoned, mountType = GetCompanionInfo("CRITTER", CritterLoop)
				if creatureSpellID == GlobalID then
					PickupCompanion("CRITTER", CritterLoop)
				end
			end
		end
	end
end
function BarProfilerPlaceAction(SlotLoop)
	if GetCursorInfo() == nil then
		PickupAction(SlotLoop)
	else
		PlaceAction(SlotLoop)
	end
	ClearCursor()
end
